#include <QPushButton>
#include <QHBoxLayout>
#include <QApplication>
#include <QSpinBox>
#include <qtextedit.h>

using namespace std;
using namespace std::chrono;

class SortingApp : public QWidget {
public:
    SortingApp(QWidget *parent = nullptr) : QWidget(parent) {
        setupUI();
    }
private:
    QSpinBox *inputField;
    QTextEdit *outputField;
    short* arr;
    unsigned short size;
    QPushButton *genButton;
    QPushButton *findButton;
    
    void setupUI() {
        QVBoxLayout *mainLayout = new QVBoxLayout(this);

        inputField = new QSpinBox(this);
        inputField->setRange(-32768,32767);
        mainLayout->addWidget(inputField);
        
        genButton = new QPushButton("Згенерувати", this);
        findButton = new QPushButton("Знайти", this);
        QPushButton *iButton = new QPushButton("Індивідуальне завдання", this);
        connect(genButton, &QPushButton::clicked, this, &SortingApp::ongenButtonClicked);
        connect(findButton, &QPushButton::clicked, this, &SortingApp::find);
        connect(iButton, &QPushButton::clicked, this, &SortingApp::ind);
        connect(inputField, &QSpinBox::valueChanged,this,&SortingApp::block);
        QHBoxLayout *buttons = new QHBoxLayout();
        buttons->addWidget(genButton);
        findButton->setDisabled(1);
        buttons->addWidget(findButton);
        buttons->addWidget(iButton);
        mainLayout->addLayout(buttons);

        outputField = new QTextEdit(this);
        outputField->setReadOnly(true);
        mainLayout->addWidget(outputField);

        setLayout(mainLayout);
        setWindowTitle("alko9");
        resize(500, 500);
    }
private slots:
    void ongenButtonClicked() {
      findButton->setEnabled(1);
      outputField->clear();
        if (!inputField->value()) size = rand() % 1000; else size = inputField->value();
        inputField->clear();
        arr = new short[size];
        arr[0] = abs(rand());
        outputField->append(QString::number(arr[0]));
        
        for (unsigned short i = 1; i < size; i++) {
            short increment = rand() % 3;
            if (arr[i-1] + increment > 32767)
                arr[i] = 32767;
            else
                arr[i] = arr[i-1] + increment;
    
            outputField->append(QString::number(arr[i]));
        }
    }
    void find() {
      unsigned short compara=0;
        bool ok;
        int target = inputField->value();
        
        int left = 0;
        int right = size - 1;
        bool found = false;
        
        outputField->append(QString("Шукаємо: %1").arg(target));

        while (left <= right) {
            int mid = left + (right - left) / 2;

            outputField->append(QString("Крок: лівий = %1, правий = %2, середній = %3")
                                 .arg(left).arg(right).arg(arr[mid]));
            compara++;

            if (arr[mid] == target) {
                outputField->append(QString("Елемент знайдено на індексі %1 за %2 порівнянь.").arg(mid).arg(compara));
                found = true;
                break;
            } else if (arr[mid] < target) {
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }

        if (!found)
            outputField->append("Елемент не знайдено.");
    }
    void ind() {
      unsigned short compara=0;
        bool ok;
        int target = arr[size-1]-5;
        
        int left = 0;
        int right = size - 1;
        unsigned short vhod=0;
        bool found = false;
        
        outputField->append(QString("Шукаємо: %1").arg(target));

        while (left <= right) {
            int mid = left + (right - left) / 2;

            outputField->append(QString("Крок: лівий = %1, правий = %2, середній = %3")
                                 .arg(left).arg(right).arg(arr[mid]));
            compara++;

            if (arr[mid] == target) {
                found = true;
                while (arr[mid]==target){
                    mid++;
                    vhod++;
                }
                mid=mid-vhod;
                while (arr[mid-1]==target){
                    mid--;
                    vhod++;
                }
                outputField->append(QString("Перше входження знайдено на індексі %1 за %2 порівнянь, всього %3 входжень.").arg(mid).arg(compara).arg(vhod));
                break;
            } else if (arr[mid] < target) {
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }

        if (!found) {
            outputField->append("Немає елемента, запитаного індивідуальним завданням");
        }
    }
    void block(){
      if (inputField->value()<0)genButton->setEnabled(false); else genButton->setEnabled(true);
    }
};

int main(int argc, char *argv[]) {
    QApplication app(argc, argv);
    SortingApp sortingApp;
    sortingApp.show();
    return app.exec();
}
